<template>
  <div class="px-10 py-12" id="content" >
    <topbar-filter
      :stargics="selectStargic"
      :budget_years="budget_years"
      @budgetYearsChange="budgetYearsChange"
      @stargicsChange="stargicsChange"
    />
    <div class="py-5">
      <div ref="mapDiv" style="width: 100%; height: 70vh" />
    </div>
  </div>
</template>

<script>
import DefaultVue from "@/Layouts/Default.vue";
import TopbarFilter from "@/Components/TopbarFilter.vue";
import { computed, onMounted, ref, toRefs } from "@vue/runtime-core";
import { Inertia } from "@inertiajs/inertia";
import { Loader } from "@googlemaps/js-api-loader";
export const GOOGLE_MAPS_API_KEY = "AIzaSyA8qjrWOJkZTiZWUvzP7kVieS_n0fZujuM";
export default {
  components: { TopbarFilter, DefaultVue },
  name: "Welcome",
  layout: DefaultVue,
  props: {
    budget_years: Array,
    selectStargic: Array,
    areas: Array,
  },

  setup(props) {
    const { budget_years, selectStargic, areas } = toRefs(props);
    const budgetYearsChange = (val) => {
      Inertia.get(route("map.index") + "/#content", { budgetYearId: val });
    };
    const stargicsChange = (val) => {
      Inertia.get(route("map.index") + "/#content", val);
    };

    const currPos = computed(() => ({
      lat: 15.116794,
      lng: 104.332348,
    }));
    const loader = new Loader({ apiKey: GOOGLE_MAPS_API_KEY });
    const mapDiv = ref(null);
    const map = ref(null);
    const infowindow = ref(null);
    const infoDiv = ref(null);
    onMounted(async () => {
      await loader.load();
      map.value = new google.maps.Map(mapDiv.value, {
        center: currPos.value,
        zoom: 9,
      });
      infowindow.value = new google.maps.InfoWindow();
      areas.value.forEach((area) => {
        const myLatlng = new google.maps.LatLng(area.lat, area.long);
        const mark = new google.maps.Marker({
          position: myLatlng,
          map: map.value,
          title: area.address,
        });

        ((mark, area) => {
          mark.addListener("click", () => {
            let infoContent = ``;
            area.projects.forEach((project) => {
              infoContent += `<li>
              <p class=" truncate " >
              ${project.name}
              </p>
              </li>`;
            });
            const content = `
            <div class=" w-56">
            <p class="mb-2">
            <b class=" font-bold">${area.address} </b>
            </p>
            <b class="font-bold">ทั้งหมด ${area.projects.length} โครงการ</b>
                <ol class="list-decimal pl-4 font-extralight">
                ${infoContent}
                </ol>
            </div>`;
            infowindow.value.setContent(content);
            infowindow.value.open({
              shouldFocus: false,
              anchor: mark,
            });
          });
        })(mark, area);
      });
    });
    return {
      budget_years,
      selectStargic,
      budgetYearsChange,
      stargicsChange,
      mapDiv,
    };
  },
};
</script>

<style>
</style>
